prologin/forum/urls.py
from django.urls import path, re_path, include

from forum import views

app_name = 'forum'

post_patterns = [
    path('', views.ThreadView.as_view(), name='thread'),
    path('edit/lock', views.EditThreadLockView.as_view(), name='edit-thread-lock'),
    path('edit/pin', views.EditThreadPinView.as_view(), name='edit-thread-pin'),
    path('edit/move', views.MoveThreadView.as_view(), name='move-thread'),
    path('delete', views.DeleteThreadView.as_view(), name='delete-thread'),
]

short_post_patterns = [
    path('', views.PostRedirectView.as_view(), name='post'),
    path('edit', views.EditPostView.as_view(), name='edit-post'),
    path('edit/visibility', views.EditPostVisibilityView.as_view(), name='edit-post-visibility'),
    path('cite', views.CitePostView.as_view(), name='cite-post'),
    path('delete', views.DeletePostView.as_view(), name='delete-post'),
]

thread_patterns = [
    # path('new-thread', views.CreateThreadView.as_view(), name='create-thread'),
    re_path(r'^(?:(?P<slug>[\w-]+)-)?(?P<pk>[0-9]+)/', include(post_patterns)),
]

urlpatterns = [
    path('', views.IndexView.as_view(), name='index'),
    re_path(r'^post/(?P<thread_slug>[\w-]+)/(?P<pk>[0-9]+)/', include(short_post_patterns)),
    re_path(r'^(?:(?P<slug>[\w-]+)-)?(?P<pk>[0-9]+)$', views.ForumView.as_view(), name='forum'),
    re_path(r'^(?:(?P<forum_slug>[\w-]+)-)?(?P<forum_pk>[0-9]+)/', include(thread_patterns)),
]

prologin/qcm/urls.py
from django.urls import path

import qcm.views

app_name = 'qcm'

urlpatterns = [
    path('', qcm.views.DisplayQCMView.as_view(), name='display'),
]

prologin/users/urls.py
from django.urls import path, include
from users import views, auth_token_views

app_name = 'users'

user_patterns = [
    path('profile', views.ProfileView.as_view(), name='profile'),
    path('edit', views.EditUserView.as_view(), name='edit'),
    path('edit/password', views.EditPasswordView.as_view(), name='edit_password'),
    path('delete', views.DeleteUserView.as_view(), name='delete'),
    path('takeout', views.TakeoutDownloadUserView.as_view(), name='takeout'),

    # Homes
    path('home/<int:year>', views.DownloadFinalHomeView.as_view(), name='download-final-home'),

    # Impersonate (django-hijack)
    path('impersonate', views.ImpersonateView.as_view(), name='impersonate'),
]

auth_token_patterns = [
    path('authorize', auth_token_views.AuthorizeView.as_view(), name='token-authorize'),
    # Internal to Prologin server, access should be restricted to internal IPs by nginx
    path('token', auth_token_views.AccessTokenView.as_view(), name='token-access'),
    path('refresh', auth_token_views.RefreshTokenView.as_view(), name='token-refresh'),
]

urlpatterns = [
    # User profile, view and edit
    path('<int:pk>/', include(user_patterns)),

    # Auth token stuff
    path('auth/', include(auth_token_patterns)),

    # Login and logout
    path('login', views.LoginView.as_view(), name='login'),
    path('logout', views.LogoutView.as_view(), name='logout'),

    # Search
    path('search/suggest', views.UserSearchSuggestView.as_view(), name='search-suggest'),

    # Password reset
    path('password/reset/ask', views.PasswordResetView.as_view(), name='password_reset'),
    path('password/reset/confirm/<uidb64>/<token>',
         views.PasswordResetConfirmView.as_view(), name='password_reset_confirm'),

    # Register and activate views
    path('register', views.RegistrationView.as_view(), name='register'),
    path('activate/<slug>', views.ActivationView.as_view(), name='activate'),

    # Mailing unsubscribe
    path('unsubscribe', views.UnsubscribeView.as_view(), name='unsubscribe'),
]

prologin/forum/models.py
from adminsortable.models import SortableMixin
from django.conf import settings
from django.urls import reverse
from django.db import models
from django.db.models import Q
from django.db.models.signals import post_save
from django.dispatch import receiver
from django.utils import timezone
from django.utils.encoding import force_text
from django.utils.functional import cached_property
from django.utils.text import slugify
from django.utils.translation import ugettext_lazy as _, ugettext_noop
from django_prometheus.models import ExportModelOperationsMixin

from prologin.models import EnumField
from prologin.utils import ChoiceEnum

from forum import managers


class Forum(ExportModelOperationsMixin('forum'), SortableMixin):
    name = models.CharField(max_length=255, verbose_name=_("Name"))
    slug = models.SlugField(max_length=300, db_index=True)
    description = models.TextField(verbose_name=_("Description"))
    order = models.IntegerField(editable=False, db_index=True)

    thread_count = models.PositiveIntegerField(verbose_name=_("Number of threads"), editable=False, blank=True, default=0)
    post_count = models.PositiveIntegerField(verbose_name=_("Number of posts"), editable=False, blank=True, default=0)

    class Meta:
        ordering = ('order',)
        verbose_name = _("Forum")
        verbose_name_plural = _("Forums")

    def __str__(self):
        return self.name

    def save(self, *args, **kwargs):
        self.slug = slugify(force_text(self.name))
        super().save(*args, **kwargs)

    @cached_property
    def last_post(self):
        return Post.visible.filter(thread__forum=self).latest()

    def update_trackers(self):
        visible_threads = Thread.objects.filter(is_visible=True, forum=self).order_by('-date_last_post')

        self.thread_count = visible_threads.count()
        self.post_count = Post.objects.filter(is_visible=True, thread__forum=self, thread__is_visible=True).count()

        try:
            self.date_last_post = visible_threads[0].date_last_post
        except IndexError:
            self.date_last_post = timezone.now()

        super().save()

    def get_absolute_url(self):
        return reverse('forum:forum', kwargs={'slug': self.slug, 'pk': self.pk})


class Thread(ExportModelOperationsMixin('thread'), models.Model):
    @ChoiceEnum.labels(str.capitalize)
    class Type(ChoiceEnum):
        normal = 0
        sticky = 1
        announce = 2
        ugettext_noop("Normal")
        ugettext_noop("Sticky")
        ugettext_noop("Announce")

    @ChoiceEnum.labels(str.capitalize)
    class Status(ChoiceEnum):
        normal = 0
        closed = 1
        moved = 2
        ugettext_noop("Normal")
        ugettext_noop("Closed")
        ugettext_noop("Moved")

    forum = models.ForeignKey(Forum, related_name='threads', on_delete=models.CASCADE)

    title = models.CharField(max_length=255, verbose_name=_("Title"))
    slug = models.SlugField(max_length=300, db_index=True)

    type = EnumField(Type, db_index=True, verbose_name=_("Thread type"), default=Type.normal.value)
    status = EnumField(Status, db_index=True, verbose_name=_("Thread status"), default=Status.normal.value)
    is_visible = models.BooleanField(default=True, db_index=True, verbose_name=_("Visible"))

    date_last_edited = models.DateTimeField(auto_now=True)
    last_edited_author = models.ForeignKey(settings.AUTH_USER_MODEL, related_name='forum_last_edited_threads',
                                           blank=True, null=True, on_delete=models.SET_NULL)

    post_count = models.PositiveIntegerField(verbose_name=_("Number of posts"), editable=False, blank=True, default=0)
    date_last_post = models.DateTimeField(verbose_name=_("Last post added on"), blank=True, null=True)  # so we can sort

    # Managers
    objects = managers.ThreadObjectManager()
    visible = managers.VisibleObjectsManager()

    class Meta:
        ordering = ('-type', '-date_last_post')
        get_latest_by = 'date_last_post'
        verbose_name = _("Thread")
        verbose_name_plural = _("Threads")

    def __str__(self):
        return self.title

    @cached_property
    def is_moved(self):
        return self.status == Thread.Status.moved.value

    @cached_property
    def is_closed(self):
        return self.status == Thread.Status.closed.value

    @cached_property
    def is_open(self):
        return not self.is_closed

    @cached_property
    def is_standard(self):
        return self.type == Thread.Type.normal.value

    @cached_property
    def is_sticky(self):
        return self.type == Thread.Type.sticky.value

    @cached_property
    def is_announce(self):
        return self.type == Thread.Type.announce.value

    @cached_property
    def date_created(self):
        return self.first_post.date_created

    @cached_property
    def author(self):
        return self.first_post.author

    @cached_property
    def first_post(self):
        # Try an externally hydrated first_post first
        if hasattr(self, '_first_post'):
            return self._first_post
        posts = self.posts.select_related('author').order_by('date_created')
        try:
            return posts[0]
        except IndexError:
            return None

    @cached_property
    def last_post(self):
        # Try an externally hydrated last_post first
        if hasattr(self, '_last_post'):
            return self._last_post
        posts = self.posts.select_related('author').order_by('-date_created')
        try:
            return posts[0]
        except IndexError:
            return None

    def mark_read_by(self, user):
        ReadState.objects.update_or_create(user=user,
                                           thread=self,
                                           defaults={'post': self.last_post})

    def save(self, *args, **kwargs):
        # Keep track of old instance so we can update the forum trackers of the old forum to which this belongs
        old_instance = None
        if self.pk:
            old_instance = self.__class__._default_manager.get(pk=self.pk)

        self.slug = slugify(force_text(self.title))
        super().save(*args, **kwargs)

        # If any change has been made to the parent forum, trigger the update of the counters
        if old_instance and old_instance.forum != self.forum:
            old_instance.forum.update_trackers()
            self.update_trackers()

    def update_trackers(self):
        posts = Post.objects.filter(thread=self)
        self.post_count = posts.count()
        self.date_last_post = posts.latest().date_created
        super().save()
        self.forum.update_trackers()

    def delete(self, using=None):
        super().delete(using)
        self.forum.update_trackers()

    def get_absolute_url(self):
        return reverse('forum:thread', kwargs={'forum_slug': self.forum.slug,
                                               'forum_pk': self.forum.pk,
                                               'slug': self.slug,
                                               'pk': self.pk})


class Post(ExportModelOperationsMixin('post'), models.Model):
    thread = models.ForeignKey(Thread, related_name='posts', on_delete=models.CASCADE)

    author = models.ForeignKey(settings.AUTH_USER_MODEL, related_name='forum_posts', on_delete=models.CASCADE)
    content = models.TextField(verbose_name=_("Content"))

    date_created = models.DateTimeField(default=timezone.now)
    date_last_edited = models.DateTimeField(auto_now=True)
    last_edited_author = models.ForeignKey(settings.AUTH_USER_MODEL, blank=True, null=True,
                                           related_name='forum_last_edited_posts', on_delete=models.SET_NULL)
    last_edited_reason = models.TextField(verbose_name=_("Edit reason"), blank=True)

    is_visible = models.BooleanField(default=True, db_index=True)

    # Managers
    objects = models.Manager()
    visible = managers.VisibleObjectsManager()

    class Meta:
        ordering = ('date_created',)
        get_latest_by = 'date_created'
        verbose_name = _("Post")
        verbose_name_plural = _("Posts")

    def __str__(self):
        return self.content[:64] + ('…' if len(self.content) > 64 else '')

    @cached_property
    def is_edited(self):
        return self.last_edited_author is not None

    @cached_property
    def is_thread_head(self):
        """
        Returns True if the post is the first post of the thread.
        """
        return self.thread.first_post.id == self.id

    @cached_property
    def is_thread_tail(self):
        """
        Returns True if the post is the last post of the thread.
        """
        return self.thread.last_post.id == self.id

    @cached_property
    def position(self):
        """
        Returns an integer corresponding to the position of the post in the thread.
        """
        return self.thread.posts.filter(Q(date_created__lt=self.date_created) | Q(pk=self.pk)).distinct().count()

    def save(self, *args, **kwargs):
        super().save(*args, **kwargs)
        if self.is_thread_head:
            if self.is_visible != self.thread.is_visible:
                self.thread.is_visible = self.is_visible
        # Trigger the thread-level trackers update
        self.thread.update_trackers()

    def get_absolute_url(self):
        thread = self.thread
        page = (self.position - 1) // settings.FORUM_POSTS_PER_PAGE + 1
        return (reverse('forum:thread', kwargs={'forum_slug': thread.forum.slug,
                                                'forum_pk': thread.forum.pk,
                                                'slug': thread.slug,
                                                'pk': thread.pk}) + '?page={}#message-{}'.format(page, self.pk))

    def get_permalink(self):
        return reverse('forum:post', kwargs={'thread_slug': self.thread.slug, 'pk': self.pk})

    def delete(self, **kwargs):
        if self.is_thread_head:

prologin/forum/forms.py
import collections
import itertools

from django import forms
from django.utils.translation import ugettext_lazy as _

from forum.models import Post, Thread

MESSAGE_CONTENT_PLACEHOLDER = _("Compose your message here. You can use the Markdown syntax.")


class PostForm(forms.ModelForm):
    class Meta:
        model = Post
        fields = ('content',)
        labels = {
            'content': '',
        }
        widgets = {
            'content': forms.Textarea(attrs={
                'placeholder': MESSAGE_CONTENT_PLACEHOLDER,
                'data-emojiable': "true",
                'data-emoji-input':"unicode",
                'rows': 4}),
        }

    def clean_content(self):
        return self.cleaned_data['content'].strip()


class UpdatePostForm(forms.ModelForm):
    class Meta:
        model = Post
        fields = PostForm.Meta.fields + ('last_edited_reason',)
        labels = {
            'content': '',
            'last_edited_reason': _("Optional explanation"),
        }
        widgets = {
            'content': forms.Textarea(attrs={
                'placeholder': MESSAGE_CONTENT_PLACEHOLDER,
                'data-emoji-input':"unicode", 'data-emojiable': "true",
                'rows': 4}),
            'last_edited_reason': forms.TextInput(attrs={
                'placeholder': _("This explanation will be shown above the message.")})
        }

    @property
    def is_thread_head(self):
        return self.instance and self.instance.is_thread_head

    def __init__(self, *args, **kwargs):
        super().__init__(*args, **kwargs)
        if self.is_thread_head:
            # Add thread title
            # Django forms are shit, so we have to rebuild the damn OrderedDict from scratch
            self.fields = collections.OrderedDict(field for field in itertools.chain(
                [('thread_title', forms.CharField(label=_("Thread title")))],
                self.fields.items()
            ))
            self.initial['thread_title'] = self.instance.thread.title

    def clean_last_edited_reason(self):
        return self.cleaned_data['last_edited_reason'].strip()


class StaffUpdatePostForm(UpdatePostForm):
    class Meta(UpdatePostForm.Meta):
        fields = UpdatePostForm.Meta.fields + ('is_visible',)
        labels = dict({'is_visible': _("Post is visible")}, **UpdatePostForm.Meta.labels)


class ThreadForm(forms.ModelForm):
    content = forms.CharField(min_length=1, required=True,
                              widget=forms.Textarea(attrs={
                                  'placeholder': MESSAGE_CONTENT_PLACEHOLDER,
                                  'data-emoji-input':"unicode",
                                  'data-emojiable': "true"}),
                              label=_("Message content"))

    class Meta:
        model = Thread
        fields = ('title', 'content')
        widgets = {
            'title': forms.TextInput(attrs={'placeholder': _("Choose a short, descriptive title.")})
        }

    def clean_title(self):
        return self.cleaned_data['title'].strip()

    def clean_content(self):
        return self.cleaned_data['content'].strip()


class MoveThreadForm(forms.ModelForm):
    class Meta:
        model = Thread
        fields = ('forum',)


class EditThreadLockForm(forms.ModelForm):
    class Meta:
        model = Thread
        fields = ('status',)
        widgets = {'status': forms.widgets.HiddenInput}


class EditThreadPinForm(forms.ModelForm):
    class Meta:
        model = Thread
        fields = ('type',)
        widgets = {'type': forms.widgets.HiddenInput}

prologin/forum/templates/forum/stub_login_required.html
{% load i18n %}

{% url 'users:register' as register %}
{% url 'users:login' as login %}
<div class="alert alert-warning">
  <i class="fa fa-user"></i>
  <div>{% blocktrans with register as register %}You have to <a href="{{ register }}">register</a> or <a href="{{ login }}">log in</a> to post messages.{% endblocktrans %}</div>
</div>

prologin/forum/templates/forum/thread_posts.html
{% extends "forum/base.html" %}
{% load humanize i18n staticfiles %}
{% load bootstrap django_bootstrap_breadcrumbs markup rules %}

{% block breadcrumbs %}
  {{ block.super }}
  {% breadcrumb_for "forum:index" %}{% trans "Forums" %}{% endbreadcrumb_for %}
  {% breadcrumb_for "forum:forum" forum.slug forum.pk %}{{ forum.name }}{% endbreadcrumb_for %}
  {% breadcrumb_for "forum:thread" forum.slug forum.pk thread.slug thread.pk %}
    {{ thread.title }}{% endbreadcrumb_for %}
  {% if is_paginated %}
    {% breadcrumb_for "" %}Page {{ page_obj.number }}{% endbreadcrumb_for %}
  {% endif %}
{% endblock breadcrumbs %}

{% block extra_head %}
  <link rel="stylesheet" type="text/css" href="{% static 'css/pygments-monokai.css' %}" media="screen"/>
  {{ block.super }}
{% endblock %}

{% block title %}{{ thread.title }}{% endblock %}

{% block content %}

  <h1>{{ thread.title }}</h1>
  {% has_perm 'forum.move_thread' request.user thread as user_can_move_thread %}
  {% if user_can_move_thread %}
    <form style="display: inline-block" action="{% url 'forum:move-thread' thread.forum.slug thread.forum.pk thread.slug thread.pk %}" method="post" class="form form-inline">
      {% csrf_token %}
      <button type="submit" class="btn btn-default">
        <i class="fa fa-random"></i>
        {% trans "Move the thread to" %}
      </button>
      {{ move_thread_form.forum|bootstrap_inline }}
    </form>
  {% endif %}
  {% has_perm 'forum.edit_thread_pin' request.user thread as user_can_pin_thread %}
  {% if user_can_pin_thread %}
    <form style="display: inline-block" action="{% url 'forum:edit-thread-pin' thread.forum.slug thread.forum.pk thread.slug thread.pk %}" method="post" class="form form-inline">
      {% csrf_token %}
      {{ edit_thread_pin_form.type }}
      <button type="submit" class="btn btn-default">
        <i class="fa fa-{% if thread.is_sticky %}circle-o{% else %}thumb-tack{% endif %}"></i>
        {% if thread.is_sticky %}{% trans "Unstick the thread" %}
        {% else %}{% trans "Stick the thread" %}{% endif %}
      </button>
    </form>
  {% endif %}
  {% has_perm 'forum.edit_thread_lock' request.user thread as user_can_lock_thread %}
  {% if user_can_lock_thread %}
    <form style="display: inline-block" action="{% url 'forum:edit-thread-lock' thread.forum.slug thread.forum.pk thread.slug thread.pk %}" method="post" class="form form-inline">
      {% csrf_token %}
      {{ edit_thread_lock_form.status }}
      <button type="submit" class="btn btn-warning">
        <i class="fa fa-{% if thread.is_closed %}un{% endif %}lock"></i>
        {% if thread.is_closed %}{% trans "Open the thread" %}
        {% else %}{% trans "Close the thread" %}{% endif %}
      </button>
    </form>
  {% endif %}
  {% has_perm 'forum.delete_thread' request.user thread as user_can_delete_thread %}
  {% if user_can_delete_thread %}
    <a href="{% url 'forum:delete-thread' thread.forum.slug thread.forum.pk thread.slug thread.pk %}"
       class="btn btn-danger">
      <i class="fa fa-trash"></i>
      {% trans "Delete thread" %}
    </a>
  {% endif %}

  {% has_perm 'forum.create_post' request.user thread as user_can_post %}
  <div class="row">
    <div class="col-sm-8 pagination-narrow">{% include "stub_pagination.html" %}</div>
    {% if user_can_post %}
      <div class="col-sm-4 text-right"><a href="#reply-thread"><i
        class="fa fa-angle-double-down"></i> {% trans "Reply to the thread" %}</a></div>{% endif %}
  </div>

  <section class="forum-post-list" id="forum-list">
    {% for post in posts %}
      <article class="forum-post clearfix" id="message-{{ post.pk }}">
        <div class="row">
          <div class="col-sm-2">
            <div class="post-author">
              <div class="row">
                <div class="col-sm-12 col-xs-7 post-author-username">
                  <div class="post-author-link"><a
                    href="{{ post.author.get_absolute_url }}">{{ post.author.username }}</a>
                  </div>
                </div>
                <div class="col-sm-12 col-xs-5 post-author-avatar">
                  {% if post.is_visible %}
                    {% if post.author.avatar_or_picture %}
                      <img class="avatar avatar-full" src="{{ post.author.avatar_or_picture.url }}"
                           alt="{% blocktrans with post.author.username as username %}{{ username }}'s profile picture{% endblocktrans %}"/>
                    {% endif %}
                    {% if post.author.is_staff %}<span class="staff-flare"><i class="fa fa-star-o"></i> {% trans "Staff member" %}</span>{% endif %}
                  {% endif %}
                </div>
              </div>
            </div>
          </div>
          <div class="col-sm-10">
            <div class="text-muted forum-meta forum-ellipsis">
              <div class="pull-right forum-actions">
                {% has_perm 'forum.edit_post' request.user post as user_can_edit_post %}
                {% has_perm 'forum.edit_post_visibility' request.user post as user_can_edit_post_visibility %}
                {% has_perm 'forum.delete_post' request.user post as user_can_delete_post %}
                {% has_perm 'forum.view_post' request.user post as user_can_view_post %}
                {% if request.user.is_authenticated and user_can_post and user_can_view_post %}
                  <a href="{% url 'forum:cite-post' thread.slug post.pk %}" class="btn btn-default btn-xs btn-cite">
                    <i class="fa fa-quote-left"></i> {% trans "Cite" %}</a>
                {% endif %}
                {% if user_can_edit_post %}
                  <a href="{% url 'forum:edit-post' thread.slug post.pk %}" class="btn btn-default btn-xs"><i
                    class="fa fa-pencil"></i> {% trans "Edit" %}</a>
                {% endif %}
                {% if user_can_edit_post_visibility %}
                  <form action="{% url 'forum:edit-post-visibility' thread.slug post.pk %}" method="POST"
                        style="display: inline">
                    {% csrf_token %}
                    <input type="hidden" name="is_visible"
                           value="{% if post.is_visible %}false{% else %}true{% endif %}">
                    <button type="submit" class="btn btn-default btn-xs"><i
                      class="fa fa-eye{% if post.is_visible %}-slash{% else %}{% endif %}"></i>
                      {% if post.is_visible %}{% trans "Hide" %}{% else %}{% trans "Unhide" %}{% endif %}</button>
                  </form>
                {% endif %}
                {% if user_can_delete_post %}
                  <a href="{% url 'forum:delete-post' thread.slug post.pk %}" class="btn btn-danger btn-xs"><i
                    class="fa fa-trash"></i> {% trans "Delete" %}</a>
                {% endif %}
              </div>
              <a href="{{ post.get_permalink }}" title="{{ post.date_created|date:"c" }}"
                 class="message-permalink">{{ post.date_created|date:"DATETIME_FORMAT" }}</a>
              {% if post.is_edited %}
                <span class="separator">⋅</span> <span class="text-muted"><i class="fa fa-pencil"></i>
                {% blocktrans with date_iso=post.date_last_edited|date:"c" date=post.date_last_edited|date:"DATETIME_FORMAT" %}Edited on <span title="{{ date_iso }}">{{ date }}</span>{% endblocktrans %}
                {% if post.last_edited_author != post.author %}{% blocktrans with username=post.last_edited_author %}by {{ username }}{% endblocktrans %}{% endif %}
                {% if post.last_edited_reason %}({{ post.last_edited_reason }}){% endif %}</span>
              {% endif %}
            </div>
            <div class="post-content tex2jax_process">
              {% if post.is_visible %}{{ post.content|flavored_markdown }}{% else %}
                <p class="text-muted"><i class="fa fa-trash"></i> {% trans "Message is deleted." %}</p>
              {% endif %}
            </div>
          </div>
        </div>
      </article>
    {% endfor %}
  </section>

  <div class="row">
    <div class="col-sm-8 pagination-narrow">{% include "stub_pagination.html" %}</div>
    <div class="col-sm-4 text-right"><a href="#forum-list"><i
      class="fa fa-angle-double-up"></i> {% trans "Back to top" %}</a></div>
  </div>

  <h3 id="reply-thread">{% trans "Reply to the thread" %}</h3>
  {% if user.is_authenticated %}
    {#{% if user_can_post %}#}
    {% if false %}
      <form method="POST">
        {% csrf_token %}
        {{ form|bootstrap }}
        <button type="submit" class="btn btn-primary"><i class="fa fa-send"></i> {% trans "Add reply" %}</button>
        <button type="submit" class="btn btn-default" formaction="#preview" name="preview" value="1"><i class="fa fa-file-text"></i> {% trans "Preview" context "Preview, the action (button)" %}</button>
      </form>
      {% if preview %}
        <h3 id="preview">{% trans "Preview" context "Preview, the noun (title)" %}</h3>
        <div class="forum-post post-content tex2jax_process">{{ form.content.value|flavored_markdown }}</div>
      {% endif %}
    {% else %}
      {# authenticated but cannot post #}
      <div class="alert alert-info">
        <i class="fa fa-lock"></i>
        <div>{% trans "Sorry, you are not allowed to post new messages in this thread." %}</div>
      </div>
    {% endif %}
  {% else %}
    {# anonymous #}
    {% include "forum/stub_login_required.html" %}
  {% endif %}

{% endblock %}

{% block extra_script %}
  {{ block.super }}
  {% include "stub-mathjax.html" %}
  <script type="text/javascript">
    /* When clicking permalinks, just scroll to message, don't do the full redirect */
    $(function() {
      var $post_textarea = $('#id_content');
      $('.message-permalink').click(function (e) {
        e.preventDefault();
        document.location.hash = $(this).parents('.forum-post').attr('id');
      });
      $('a[href="#reply-thread"]').click(function () {
        try {
          $post_textarea.focus();
        } catch (e) {
        }
      });
      $('.btn-cite').click(function(e) {
        e.preventDefault();
        var cite_url = $(this).attr('href');
        $.getJSON(cite_url)
          .done(function(data) {
            $post_textarea.val($post_textarea.val() + '\n' + data.message);
            var $editor = $('.emoji-wysiwyg-editor');
            $editor[0].innerHTML = $post_textarea.val()
          })
          .fail(function(err) {
            console.error(err);
          });
      });
    });
  </script>
{% endblock %}